## 基于 vue + moxie 的文件选择组件

### 组件文件

| 组件名称 | 组件路径 | 组件说明
| :--- | :--- | :--- |
| nftn-moxie-file | /components/moxie/file.vue | 文件选择组件 |

### 依赖内容
| 依赖名称 | 依赖路径 | 依赖说明
| :--- | :--- | :--- |
| nftn-moxie-container | /components/moxie/container.vue | 文件预览按比例显示 |
| mOxie | https://github.com/moxiecode/moxie | 跨浏览器文件API库 |

### Props
| 参数名称 | 参数类型 | 参数说明 | 可选值 | 默认值 |
| :--- | :--- | :--- | :--- | :--- |
| --- __显示相关__ --- |
| ratio | String | 预览比例 | '1:1' <br> '2:1' <br> '3:1' <br> '3:2' <br> '4:3' <br> '6:4' <br> '16:9' | '1:1' |
| disabled | Boolean | 是否禁用 | true <br> false | false |
| --- __功能相关__ --- |
| extensions | String | 可选文件类型 | -- | '*' |
| size | Number | 文件大小限制（KB）<br> 0 无限制 | -- | `5120` |
| multiple | Boolean | 是否多选 | true <br> false | false |
| max | Number | 可选数量限制 `multiple=true` <br> 0 无限制 | 0~? | 0 |
| action | String<br>Object | 上传地址 | -- <br> `{ url: String, method: String }` | -- |
| postData | Object | 上传数据 | `{ Key: Value, ... }` | `{}` |
| --- __事件相关__ --- |
| onChange | Function(files)<br>- files: Array | 文件选择后触发 | -- | `$emit('input', Array)` |
| onError  | Function(errors)<br>- errors: Array | 文件选择发生错误 | -- | `alert(String)` |
| --- __其他___ --- |
| value | String <br> Array <br> Object | `v-model` | -- | '' |
| configs | Object | 所有 props 集合 | -- | {} |
