## 基于 vue + moxie 的文件预览组件

### 组件文件

| 组件名称 | 组件路径 | 组件说明
| :--- | :--- | :--- |
| nftn-moxie-preview | /components/moxie/preview.vue | 文件预览组件 |

### 依赖内容
| 依赖名称 | 依赖路径 | 依赖说明
| :--- | :--- | :--- |
| nftn-moxie-container | /components/moxie/container.vue | 文件预览按比例显示 |
| mOxie | https://github.com/moxiecode/moxie | 跨浏览器文件API库 |

### Props
| 参数名称 | 参数类型 | 参数说明 | 可选值 | 默认值 |
| :--- | :--- | :--- | :--- | :--- |
| --- __显示相关__ --- |
| *file | String <br> Object | 访问地址 <br> 预览文件 | -- | -- |
| urlAppend | String | 访问地址后添加 <br> `file => String` | -- | -- |
| previewAppend | String | 预览地址后添加 <br> `file => String` | -- | -- |
| ratio | String | 预览比例 | `'1:1'` <br> `'2:1'` <br> `'3:1'` <br> `'3:2'` <br> `'4:3'` <br> `'6:4'` <br> `'16:9'` | `'1:1'` |
| mode | String | 显示模式 | `'bg'` | `'bg'` |
| bgSize | String | 显示背景图模式<br>`mode='bg'` | `'cover'`<br>`'contain'` | `'cover'`
| --- __功能相关__ --- |
| type | String | 以说明方式显示 | `'*'` <br> `'image'` <br> `'video'` <br> `'file'` | `'*'` |
| data | String <br> Object | 额外数据<br>- 子组件无法定位集合索引时可用 | -- | -- |
| --- __事件相关__ --- |
| onClick | Function(url, data)<br>- url: String<br>- data: [String, Object] | 点击预览时触发 | -- | -- |
| onError | Function () | 文件读取失败时触发 | -- | -- |
| --- __其他___ --- |
| configs | Object | 所有 props 集合 | -- | `{}` |

### 后续想法
- [ ] 20170721 设置显示类型 `v-bind:type`
- [ ] 20170721 支持自动识别显示类型
- [ ] 20170721 添加 &lt;video&gt;&lt;/video&gt;
- [ ] 20170721 添加文件图标
